//+------------------------------------------------------------------+

//|                                              keltner-channel.mq4 |

//|      Copyright ? 2011 Forex-indikatoren.com. All rights reserved |

//|                                 http://www.forex-indikatoren.com |

//+------------------------------------------------------------------+

#property copyright "Copyright ? 2011 Forex-indikatoren.com."

#property link      "http://www.forex-indikatoren.com"



#property indicator_chart_window

#property indicator_buffers 3

#property indicator_color1 Tomato

#property indicator_color2 DodgerBlue

#property indicator_color3 Tomato

//---- input parameters

extern int period = 10;

//----

double u[], m[], l[];

//+------------------------------------------------------------------+

//| Custom indicator initialization function                         |

//+------------------------------------------------------------------+

int init()

  {

   SetIndexBuffer(0, u);

   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID, 2);

   SetIndexShift(0, 0);

   SetIndexDrawBegin(0, 0);

//----

   SetIndexBuffer(1, m);

   SetIndexStyle(1, DRAW_LINE, STYLE_DASHDOT);

   SetIndexShift(1, 0);

   SetIndexDrawBegin(1, 0);

//----

   SetIndexBuffer(2, l);

   SetIndexStyle(2, DRAW_LINE,STYLE_SOLID, 2);

   SetIndexShift(2, 0);

   SetIndexDrawBegin(2, 0);

//---- name for DataWindow label

   SetIndexLabel(0, "KCUp(" + period + ")");    

   SetIndexLabel(1, "KCMid(" + period + ")"); 

   SetIndexLabel(2, "KCLow(" + period + ")"); 

//----

    

   return(0);

  }

//+------------------------------------------------------------------+

//| Custor indicator deinitialization function                       |

//+------------------------------------------------------------------+

int deinit()

  {

//----

   

   return(0);

  }

//+------------------------------------------------------------------+

//| Custom indicator iteration function                              |

//+------------------------------------------------------------------+

int start() 

  {

   int limit;

   double avg;   

   int counted_bars = IndicatorCounted();

   if(counted_bars < 0) 

       return(-1);

   if(counted_bars > 0) 

       counted_bars--;

   limit = Bars - counted_bars;

//----

   for(int x = 0; x < limit; x++) 

     {

      m[x] = iMA(NULL, 0, period, 0, MODE_SMA, PRICE_TYPICAL, x);

      avg = findAvg(period, x);

      u[x] = m[x] + avg;

      l[x] = m[x] - avg;

     }

   return(0);

  }

//+------------------------------------------------------------------+

//|                                                                  |

//+------------------------------------------------------------------+  

double findAvg(int period, int shift) 

  {

   double sum = 0;

   for(int x = shift; x < (shift + period); x++) 

     {     

       sum += High[x] - Low[x];

     }

   sum = sum / period;

   return(sum);

  }  

//+------------------------------------------------------------------+








